﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.OleDb;

namespace consolerevisaosimulado_2
{
    class Program
    {
        public static class Access
        {
            public static OleDbConnection AbrirConexao()
            {
                return new OleDbConnection(@"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=D:\sergio\banco.mdb");
            }
        }



        public class Musicas
        {
            private string cantor_banda { get; set; }
            private string nome_da_musica { get; set; }

            public void Preencherdados()
            {
                Console.Write("Informe o nome do cantor ou banda: ");
                this.cantor_banda = Console.ReadLine();
                Console.Write("Informe o nome da musica: ");
                this.nome_da_musica = Console.ReadLine();
            }

            public void Preencherdados(string cantor_banda, string musica)
            {
                this.cantor_banda = cantor_banda;
                this.nome_da_musica = musica;
            }

            public void Mostrardados()
            {
                Console.WriteLine("{0} - {1}", this.cantor_banda, this.nome_da_musica);
            }

            public void InsereMusica()
            {
                Preencherdados();
                OleDbConnection conexao = Access.AbrirConexao();
                OleDbCommand comando = new OleDbCommand();
                comando.Connection = conexao;
                comando.CommandText = "Insert into musicas values (\"" + this.cantor_banda + "\",\"" + this.nome_da_musica + "\")";
                try
                {
                    conexao.Open();
                    comando.ExecuteNonQuery();
                    conexao.Close();
                    Console.WriteLine("A música {0} foi inserida.", this.nome_da_musica);
                }
                catch (OleDbException erro)
                {
                    Console.WriteLine("Erro: {0}", erro.Errors[0].Message);
                }
            }

            public bool BuscaMusica()
            {
                string qualmusica;
                Console.Write("Qual música deseja buscar? ");
                qualmusica = Console.ReadLine();

                OleDbConnection cnn = Access.AbrirConexao();
                OleDbCommand cmd = new OleDbCommand();
                cmd.Connection = cnn;
                cmd.CommandText = "Select * from musicas where nome_da_musica = \"" + qualmusica + "\"";
                OleDbDataReader resultado;
                try
                {
                    cnn.Open();
                    resultado = cmd.ExecuteReader();
                    if (resultado.HasRows)
                    {
                        resultado.Read();
                        Preencherdados(resultado["cantor_banda"].ToString(), resultado[1].ToString());
                        Console.WriteLine("Musica encontrada: ");
                        Mostrardados();
                        cnn.Close();
                        return true;
                    }
                    else
                    {
                        Console.WriteLine("A musica {0} não foi encontrada. ", qualmusica);
                        cnn.Close();
                        return false;
                    }

                }
                catch (OleDbException erro)
                {
                    Console.WriteLine("Erro: {0}", erro.Errors[0].Message);
                }
                return false;
            }

            public void AteraMusica()
            {
                bool achouamusica = false;
                string alteracao = "";
                string qualmusica;
                achouamusica = this.BuscaMusica();
                if (achouamusica == true)
                {
                    qualmusica = this.nome_da_musica;
                    Console.Write("Digite o nome do cantor ou banda (ou ENTER para não alterar): ");
                    alteracao = Console.ReadLine();
                    if (alteracao != "")
                    {
                        this.cantor_banda = alteracao;
                    }
                    alteracao = "";
                    Console.Write("Digite o nome da música (ou ENTER para não alterar): ");
                    alteracao = Console.ReadLine();
                    if (alteracao != "")
                    {
                        this.nome_da_musica = alteracao;
                    }
                    OleDbConnection conexao = Access.AbrirConexao();
                    OleDbCommand comando = new OleDbCommand();
                    comando.Connection = conexao;
                    comando.CommandText = "UPDATE MUSICAS SET CANTOR_BANDA = \'" + this.cantor_banda + "\',NOME_DA_MUSICA = \'" + this.nome_da_musica + "\' where nome_da_musica = \'" + qualmusica + "\'";
                    try
                    {
                        conexao.Open();
                        comando.ExecuteNonQuery();
                        Console.WriteLine("A musica {0} foi alterada para {1} - {2}", qualmusica, this.nome_da_musica, this.cantor_banda);
                        conexao.Close();
                    }
                    catch (OleDbException erro)
                    {
                        Console.WriteLine("Erro: {0}", erro.Errors[0].Message);
                    }
                }
            }
            public void ListaMusicas()
            {
                OleDbConnection conexao = Access.AbrirConexao();
                OleDbCommand cmd = new OleDbCommand();
                cmd.Connection = conexao;
                cmd.CommandText = "Select * from musicas order by nome_da_musica";
                OleDbDataReader resultado;
                try
                {
                    conexao.Open();
                    resultado = cmd.ExecuteReader();
                    if (resultado.HasRows)
                    {
                        int quantas = 0;
                        Console.WriteLine("\nLista das múscas em ordem alfabética:");
                        while (resultado.Read())
                        {
                            this.Preencherdados(resultado[0].ToString(), resultado[1].ToString());
                            this.Mostrardados();
                            quantas++;
                        }
                        Console.WriteLine("---------------------- Total de {0} músicas", quantas.ToString());
                    }
                    else
                    {
                        Console.WriteLine("Não existe nenhum registro a ser mostrado!");
                    }
                }
                catch (OleDbException erro)
                {
                    Console.WriteLine("Erro: {0}", erro.Errors[0].Message);
                }
            }



            public void ApagarMusica()
            {
                bool achoumusica = false;
                achoumusica = this.BuscaMusica();
                if (achoumusica == true)
                {
                    Console.Write("Deseja aagar a músca {0} (S/N)? ", this.nome_da_musica);
                    if (Console.ReadLine().ToUpper() == "S")
                    {
                        OleDbConnection cnn = Access.AbrirConexao();
                        OleDbCommand cmd = new OleDbCommand();
                        cmd.Connection = cnn;
                        cmd.CommandText = "DELETE FROM MUSICAS WHERE NOME_DA_MUSICA = \'" + this.nome_da_musica + "\'";
                        try
                        {
                            cnn.Open();
                            cmd.ExecuteNonQuery();
                            Console.WriteLine("Musica {0} apagada.", this.nome_da_musica);
                            cnn.Close();
                        }
                        catch (OleDbException erro)
                        {
                            Console.WriteLine("Erro: {0}", erro.Errors[0].Message);
                        }
                    }
                    else
                    {
                        Console.WriteLine("A música não foi apagada!");
                    }
                }
            }

        }

        static void Main(string[] args)
        {
            Musicas teste = new Musicas();
            teste.ListaMusicas();
            Console.WriteLine("Fim");
            Console.ReadKey();
        }
    }
}
